#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %cgiparams;

@shortmonths = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug",
	"Sep", "Oct", "Nov", "December" );
@longmonths = ( "January", "Februrary", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December" );

print "Content-type: text/html\n\n";

@now = localtime(time);

$cgiparams{'DAY'} = $now[3];
$cgiparams{'MONTH'} = $now[4];

&getcgihash(\%cgiparams);

&openpage('Firewall log');
&openbigbox('100%', 'LEFT');

&openbox('100%', 'LEFT', 'Date:');

print <<END
<FORM METHOD='POST'>
<TABLE WIDTH='100%'>
<TR>
	<TD>Month:</TD>
	<TD>
	<SELECT NAME='MONTH'>
END
;
for ($month = 0; $month < 12; $month++)
{
	print "\t<OPTION ";
	if ($month == $cgiparams{'MONTH'}) {
		print 'SELECTED '; }
	print "VALUE='$month'>$longmonths[$month]\n";
}
print <<END
	</SELECT>
	</TD>
	<TD>Day:</TD>
	<TD>
	<SELECT NAME='DAY'>
END
;
for ($day = 1; $day <= 31; $day++) 
{
	print "\t<OPTION ";
	if ($day == $cgiparams{'DAY'}) {
		print 'SELECTED '; }
	print "VALUE='$day'>$day\n";
}
print <<END
</SELECT>
</TD>
<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Update'></TD>
</TR>
</TABLE>
</FORM>
END
;

&closebox();

$monthstr = $shortmonths[$cgiparams{'MONTH'}];
$day = $cgiparams{'DAY'};
if ($day <= 9) {
	$daystr = " $day"; }
else {
	$daystr = $day; }

&openbox('100%', 'LEFT', 'Firewall log:');
open (FILE, '/var/log/messages');
print <<END
<TABLE WIDTH='100%'>
<TR>
	<TD ALIGN='CENTER'><B>Time</B></TD>
	<TD ALIGN='CENTER'><B>Chain</B></TD>
	<TD ALIGN='CENTER'><B>Protocol</B></TD>
	<TD ALIGN='CENTER'><B>Source</B></TD>
	<TD ALIGN='CENTER'><B>Src Port</B></TD>
	<TD ALIGN='CENTER'><B>Destination</B></TD>
	<TD ALIGN='CENTER'><B>Dst Port</B></TD>
</TR>
<TR>
END
;
while (<FILE>)
{
	if (/(^${monthstr} ${daystr} ..:..:..) \w+ kernel: Packet log: (.*)/)
	{
		$timestamp = $1; $packet = $2;
		$timestamp =~ /... (..) (..:..:..)/;
		$day = $1; $time = $2;

		if ($packet =~ /(\w+ - \w+) PROTO=(.*?) (.*?) (.*?) (.*)/)
		{
			$where = $1; $proto = $2; $src = $3; $dst = $4;
			$src =~ /([\d.]+):(\d+)/;
			$srcaddr = $1; $srcport = $2;
			$dst =~ /([\d.]+):(\d+)/;
			$dstaddr = $1; $dstport = $2;
			if ($proto == 6) { 
				$protostr = 'TCP'; }
			elsif ($proto == 17) {
				$protostr = 'UDP'; }
			else {
				$protostr = 'UNKNOWN'; }
			print <<END
<TR>
	<TD ALIGN='CENTER'>$time</TD>
	<TD ALIGN='CENTER'>$where</TD>
	<TD ALIGN='CENTER'>$protostr</TD>
	<TD ALIGN='CENTER'>$srcaddr</TD>
	<TD ALIGN='CENTER'>$srcport</TD>
	<TD ALIGN='CENTER'>$dstaddr</TD>
	<TD ALIGN='CENTER'>$dstport</TD>
</TR>
END
			;
		}
	}
}
close (FILE);
print "</TABLE>\n";
print "&nbsp;\n";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
<TR>
	<TD ALIGN='CENTER'><A HREF='/cgi-bin/index.cgi'>BACK</A></TD>
	<TD ALIGN='CENTER'><A HREF='/configure.html#3.7.'>HELP</A></TD>
</TR>
</TABLE>
</DIV>
END
;

&closebigbox();

&closepage();
