#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %cgiparams;

@shortmonths = ( 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug',
	'Sep', 'Oct', 'Nov', 'December' );
@longmonths = ( 'January', 'Februrary', 'March', 'April', 'May', 'June',
	'July', 'August', 'September', 'October', 'November', 'December' );
%filters = ( 'ppp' => '(pppd|chat)\[.*\]', 'dhcp' => '(dhcpd)',
	'kernel' => '(kernel)');

print "Content-type: text/html\n\n";

@now = localtime(time);

$cgiparams{'DAY'} = $now[3]; 
$cgiparams{'MONTH'} = $now[4];
$cgiparams{'SECTION'} = 'ppp';
&getcgihash(\%cgiparams);

$selected{'SECTION'}{'ppp'} = '';
$selected{'SECTION'}{'dhcp'} = '';
$selected{'SECTION'}{'kernel'} = '';
$selected{'SECTION'}{$cgiparams{'SECTION'}} = 'SELECTED';

&openpage('Log viewer');
&openbigbox('100%', 'LEFT');

&openbox('100%', 'LEFT', 'Section and date:');

print <<END
<FORM METHOD='POST'>
<TABLE WIDTH='100%'>
<TR>
	<TD>Section:</TD>
	<TD><SELECT NAME='SECTION'>
	<OPTION $selected{'SECTION'}{'ppp'} VALUE='ppp'>PPP
	<OPTION $selected{'SECTION'}{'dhcp'} VALUE='dhcp'>DHCP server
	<OPTION $selected{'SECTION'}{'kernel'} VALUE='kernel'}>Kernel
	</SELECT>
	</TD>
	<TD>Month:</TD>
	<TD>
	<SELECT NAME='MONTH'>
END
;
for ($month = 0; $month < 12; $month++)
{
	print "\t<OPTION ";
	if ($month == $cgiparams{'MONTH'}) {
		print 'SELECTED '; }
	print "VALUE='$month'>$longmonths[$month]\n";
}
print <<END
	</SELECT>
	</TD>
	<TD>Day:</TD>
	<TD>
	<SELECT NAME='DAY'>
END
;
for ($day = 1; $day <= 31; $day++) 
{
	print "\t<OPTION ";
	if ($day == $cgiparams{'DAY'}) {
		print 'SELECTED '; }
	print "VALUE='$day'>$day\n";
}
print <<END
	</SELECT>
	</TD>
	<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Update'></TD>
</TR>
</TABLE>
</FORM>
END
;

&closebox();

$monthstr = $shortmonths[$cgiparams{'MONTH'}];
$day = $cgiparams{'DAY'};
if ($day <= 9) {
	$daystr = " $day"; }
else {
	$daystr = $day; }

$filter = $filters{$cgiparams{'SECTION'}};

&openbox('100%', 'LEFT', 'Log:');
open (FILE, '/var/log/messages');
print "<TT>\n";
while (<FILE>)
{
	if (/^${monthstr} ${daystr} (..:..:..) \w+ ${filter}: (.*)/)
	{
		print "$1 $2 $3<BR>\n";
	}
}
print "</TT>\n";
close (FILE);
print "&nbsp;\n";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
<TR>
	<TD ALIGN='CENTER'><A HREF='/cgi-bin/index.cgi'>BACK</A></TD>
	<TD ALIGN='CENTER'><A HREF='/configure.html#3.6.'>HELP</A></TD>
</TR></TABLE>
</DIV>
END
;

&closebigbox();

&closepage();
